Decision = class("Decision")

joystickTimer = require 'lovestory.timer'

decisionbox = love.graphics.newImage("lovestory/assets/decisionbox.png")
decisioncursor = love.graphics.newImage("lovestory/assets/decisioncursor.png")
decisionOKSound = love.audio.newSource("lovestory/assets/decisionOK.wav", "static")
decisionCursorSound = love.audio.newSource("lovestory/assets/decisionCursor.wav", "static")

function Decision:init() -- option = string | callback = function

	self.options = {}
	self.callbacks = {}
	
	self.answer = 0
	self.cursor = 1

end

function Decision:define(option1,callback1,option2,callback2,option3,callback3,option4,callback4) -- option = string | callback = function

	if(option1 == nil)then
		return
	end

	self.options[1] = option1
	self.options[2] = option2
	self.options[3] = option3
	self.options[4] = option4
	
	self.callbacks[1] = callback1
	self.callbacks[2] = callback2
	self.callbacks[3] = callback3
	self.callbacks[4] = callback4
	
	joystickTimer:start()
end

function Decision:getOptionCount()
	count = 0
	if(self.options[1] ~= nil)then
		count = count +1
	else
		return count
	end
	if(self.options[2] ~= nil)then
		count = count +1
	else
		return count
	end
	if(self.options[3] ~= nil)then
		count = count +1
	else
		return count
	end
	if(self.options[4] ~= nil)then
		count = count +1
	else
		return count
	end
	
	return count
end

function Decision:touchreleased(id,x,y,dx,dy,pressure)

	maxOption = self:getOptionCount()

	if(x > 75 and x < 1190 and y > 55 and y < 160 and maxOption > 0)then
		if(self.cursor == 1)then
			self.answer = self.cursor
			soundManager:playSound(decisionOKSound)
		else
			self.cursor = 1
			soundManager:playSound(decisionCursorSound)
		end
		return
	end
	if(x > 75 and x < 1190 and y > 224 and y < 330 and maxOption > 1)then
		if(self.cursor == 2)then
			self.answer = self.cursor
			soundManager:playSound(decisionOKSound)
		else
			self.cursor = 2
			soundManager:playSound(decisionCursorSound)
		end
		return
	end
	if(x > 75 and x < 1190 and y > 395 and y < 500 and maxOption > 2)then
		if(self.cursor == 3)then
			self.answer = self.cursor
			soundManager:playSound(decisionOKSound)
		else
			self.cursor = 3
			soundManager:playSound(decisionCursorSound)
		end
		return
	end
	if(x > 75 and x < 1190 and y > 565 and y < 670 and maxOption > 3)then
		if(self.cursor == 4)then
			self.answer = self.cursor
			soundManager:playSound(decisionOKSound)
		else
			self.cursor = 4
			soundManager:playSound(decisionCursorSound)
		end
		return
	end
end

function Decision:gamepadpressed(joystick,button)
	if(self.answer > 0)then
		return --ALREADY DECIDED
	end

	maxOption = self:getOptionCount()

	if(button == "a")then
		self.answer = self.cursor
		soundManager:playSound(decisionOKSound)
	end
	if(button == "dpup")then
		if(self.cursor > 1)then  -- MIN = 1
			self.cursor = self.cursor - 1
			soundManager:playSound(decisionCursorSound)
		end
	end
	if(button == "dpdown")then
		if(self.cursor < maxOption)then  -- MAX = ?
			self.cursor = self.cursor + 1
			soundManager:playSound(decisionCursorSound)
		end
	end
end

function Decision:gamepadaxis(joystick, axis, value, threshhold)
	delayTime = 0.2
	if(axis == "lefty") then
		if(value < -threshhold) then
			if(joystickTimer:isPast(delayTime))then
				self:gamepadpressed(joystick,"dpup")
			end
			return
		elseif(value > threshhold) then
			if(joystickTimer:isPast(delayTime))then
				self:gamepadpressed(joystick,"dpdown")
			end
			return
		end
	end
	if(axis == "righty") then
		if(value < -threshhold) then
			if(joystickTimer:isPast(delayTime))then
				self:gamepadpressed(joystick,"dpup")
			end
			return
		elseif(value > threshhold) then
			if(joystickTimer:isPast(delayTime))then
				self:gamepadpressed(joystick,"dpdown")
			end
			return
		end
	end
end

function Decision:callback()
	c = self.callbacks[self.answer]
	if(c ~= nil)then
		c()
	end
end

function Decision:getAnswer()
	return self.answer
end

function Decision:getOption(i)
	return self.options[i]
end

function Decision:draw()

	x = 120
	y = 90
	yOffset = 170
	i = 1
	
	cursorY = y + (self.cursor-1)*yOffset - 20
	maxCount = self:getOptionCount()
	
	for i=1,maxCount do
		love.graphics.draw(decisionbox, 0, y-40)
		love.graphics.print(self.options[i], x, y)
		i = i + 1
		y = y + yOffset
	end
	
	love.graphics.draw(decisioncursor,1100, cursorY)
	
end

return Decision()