SoundManager = class("soundManager")

function SoundManager:init()

    self.musicOn = true
    self.soundOn = true

    self.loadedMusic = {}
    self.loadedSounds = {}
end

function SoundManager:stop()
    love.audio.stop()
end

function SoundManager:playSound(sound)
    if(self.soundOn)then
        love.audio.play(sound)
    end
end

function SoundManager:playSoundFromSource(path)

	if(self.loadedSounds[path] == nil)then
		self.loadedSounds[path] = love.audio.newSource(path, "static")
    end
    
	if(self.loadedSounds[path]==nil)then
        error("LoveStory: SoundManager could not find file: "..path.." !")
        return
	end

    local sound = self.loadedSounds[path]
    if(self.soundOn)then
        love.audio.play(sound)
    end
end

function SoundManager:playMusic(music)
    if(self.musicOn)then
        love.audio.play(music)
    end
end

function SoundManager:playMusicFromSource(path)

    if(self.loadedMusic[path] == nil)then
        self.loadedMusic[path] = love.audio.newSource(path, "stream")
    end
    
	if(self.loadedMusic[path]==nil)then
        error("LoveStory: SoundManager could not find file: "..path.." !")
        return
	end

    local music = self.loadedMusic[path]
    if(self.musicOn)then
        music:setLooping(true)
        love.audio.play(music)
    end
end


return SoundManager()