class = require '30log' --Required for LoveStory
lovestory = require 'lovestory.lovestory' --Required for LoveStory

require 'preload.preload'

preloadShrike = Preload("preload/assets/logoShrike.png","preload/assets/wuff.wav",200,500,200) -- FRAMES: 50 = FULLSCREEN | 300 = LOGO (small)
preloadLovePotion = Preload("preload/assets/logoLP.png","preload/assets/jingle.wav",250,460,160) -- FRAMES: 50 = FULLSCREEN | 300 = LOGO (small)

dtotal = 0
joyconPair = nil
preloaderEnabled = true

function love.load()  										---------- LOAD
	
	novel:setupLoveStory(lovestory) --init lovestory
	
	love.math.setRandomSeed(os.time())

	--gametime
	dtotal = 0 
	framespeed = 0.07
	
	novel:start() --Loads first story-part inside story.lua

 end

function love.update(dt)									---------- UPDATE

	--GAME SPEED-------------------
	--gametime framespeed
	if dt < 1 then --error fix
	dtotal = dtotal + dt
	end
	if dtotal < framespeed then
		return --SKIP FRAME, DO NOTHING
    end
	dtotal = dtotal - framespeed --update gametime
	---------------------------------------------

	if(preloaderEnabled)then
		if(not (preloadLovePotion:getFinished() and preloadShrike:getFinished()))then  --PRELOADER WAIT
			return
		end
	end
	
	lovestory:update() --Handles Decision Input
	
	if(lovestory:isBusy())then
		return --Do no game updates until dialogue is finished
	end
	
	-- -- HERE COMES CODE THAT RUNS WHEN THERE IS NO MORE STORY TELLING GOING ON
	-- -- .. *your game code here* ..
	-- -- ...........................
 	
 end

function love.gamepadpressed(joystick, button) 				-------- GAMEPAD
	
	if(joyconPair == nil) then
		joyconPair = joystick --register joystick
	end
	
	if(preloaderEnabled)then
		if(preloadShrike:checkSkip(joystick,button))then --Checks if preload is skipped
			return
		end
		if(preloadLovePotion:checkSkip(joystick,button))then --Checks if preload is skipped
			return
		end
	end
	
	lovestory:gamepadpressed(joystick,button) --Handles LoveStory Input
	
end

function love.gamepadreleased(joystick, button)
	lovestory:gamepadreleased(joystick,button)   --Handles LoveStory Input
end

function love.gamepadaxis(joystick, axis, value)			-------- AXIS
	
	threshhold = 0.7

	if(joyconPair == nil) then  
		joyconPair = joystick 	--register joystick
	end
	
	lovestory:gamepadaxis(joystick, axis, value, threshhold)
end

function love.touchreleased(id,x,y,dx,dy,pressure)			-------- TOUCH POINT

	if(preloaderEnabled)then
		if(preloadShrike:getFinished() == false)then
			preloadShrike:setFinished()
			return
		end
		if(preloadLovePotion:getFinished() == false)then
			preloadLovePotion:setFinished()
			return
		end
	end

	lovestory:touchreleased(id,x,y,dx,dy,pressure)

end

function love.touchmoved(id,x,y,dx,dy,pressure)				-------- TOUCH MOVE
		lovestory:touchmoved(id,x,y,dx,dy,pressure)
end		        

function love.draw()										------- DRAW
	
	-- PRELOADER DRAW() ---
	if(preloaderEnabled)then
		if(not preloadShrike:getFinished())then
			preloadShrike:draw()
			return
		end
		if(not preloadLovePotion:getFinished())then
			preloadLovePotion:draw()
			return
		end
	end
	love.graphics.setColor(1,1,1,1)
	------------------------
	
	lovestory.draw()
	
 end