Preload = class("Preload")

function Preload:init(imgPath,wavPath,maxFrames,x,y)

	if(imgPath == nil)then
		return
	end
	
	love.graphics.setBackgroundColor(0, 0, 0)
	
	self.finished = false
	self.image = love.graphics.newImage(imgPath)
	
	if(wavPath == nil)then
		self.sound = nil
	else
		self.sound = love.audio.newSource(wavPath, "static")
	end
	
	self.maxFrames = maxFrames
	self.currentFrame = 0
	
	self.x = x
	self.y = y
end

function Preload:checkSkip(joystick,button)
	if((not self:getFinished()) and (button == "plus" or button == "a" or button == "b"))then 
		self:setFinished()
		return true
	end
end

function Preload:getFinished()
	return self.finished
end

function Preload:setFinished()
	self.finished = true
end

function Preload:draw()

	self.currentFrame = self.currentFrame +1 -- Count Frames

	-- SKIP BUTTON --
	if(self.finished == true)then
		alpha = 0
		return
	end
	-------------------------------------
	
	if(self.currentFrame < self.maxFrames/3)then	-- Smooth Graphic Drawing
		alpha = self.currentFrame/(self.maxFrames/3)
	else
		if(self.currentFrame < 2*self.maxFrames/3)then
			alpha = 1
			if(self.currentFrame == math.floor(self.maxFrames/2))then --SOUND
				if(self.sound ~= nil)then
					love.audio.play(self.sound)
				end
			end
		else
			if(self.currentFrame < self.maxFrames)then
				alpha = 1 - (self.currentFrame - 2*(self.maxFrames/3))/(self.maxFrames/3)
			else -- self.currentFrame >= self.maxFrames
				alpha = 0
				self.finished = true
			end
		end
	end
	love.graphics.setColor(1,1,1,alpha)
	love.graphics.draw(self.image, self.x, self.y)
end

return Preload()